#ifndef LINEARSPIRAL_H
#define LINEARSPIRAL_H

#include <SFML/Graphics.hpp>
#include "tools.h"

class LinearSpiral
{
    public:
        LinearSpiral();
        virtual ~LinearSpiral();

        void setParameters(float, float, bool = true);

        float ComputeBest(sf::Vector2f, std::vector<pt_datum>);
        sf::Vector2f ComputeBestCenter(sf::Vector2f, std::vector<pt_datum>);

        void Draw(sf::RenderTarget *, sf::Vector2f, sf::Color = sf::Color::Black);
        void DrawDot(sf::RenderTarget *, sf::Vector2f, float,sf::Color = sf::Color::Black);
        void DrawArc(sf::RenderTarget *, sf::Vector2f, float, float,sf::Color = sf::Color::Black);

        std::string printValues();

    protected:

    private:
        float m_sradius;
        float m_rate;
        bool  m_orientation;

        float m_fit;
};

#endif // LINEARSPIRAL_H
