#include <iostream>
#include <math.h>
#include <SFML/Graphics.hpp>
#include <dirent.h>
#include <fstream>
#include <sstream>
#include "tools.h"
#include "LinearSpiral.h"
#include "LogSpirale.h"


using namespace std;



int main()
{
    sf::ContextSettings settings;
    settings.antialiasingLevel = 16;
    sf::RenderWindow window(sf::VideoMode(800, 800), "Superb Spirals", sf::Style::Default, settings);

    float zoom = 1;
    sf::View view(sf::FloatRect(0, 0, 800, 800));
    window.setView(view);

    sf::Clock clock;


    LinearSpiral lin_spire, lin_outer_spire;
    LogSpiral log_spire, log_outer_spire;

    sf::Vector2f mouse(0,0);
    unsigned int cur_ammonite = 0;

    std::vector<std::string> list_ammonites;

    struct dirent *lecture;

    DIR *repertoire;
    repertoire = opendir("img");

    while ((lecture = readdir(repertoire)))
    {
        std::string name = lecture->d_name;
        if(/*name.find("sav.hs") != string::npos && */name != "." && name != "..")
            list_ammonites.push_back(name);
    }

    closedir(repertoire);

    ofstream fichier("output/output.txt", ios::out | ios::trunc);

    //sf::Font font;
    font.loadFromFile("arial.ttf");

    sf::Texture texture;
    texture.loadFromFile("img/"+list_ammonites[0]);
    sf::Sprite sprite;
    sprite.setTexture(texture);

    sf::Vector2u screen_size = texture.getSize();
    if(screen_size.x > 1000)
        screen_size.x = 1000;
    if(screen_size.y > 700)
        screen_size.y = 700;
    window.setSize(screen_size);
    view = sf::View(sf::FloatRect(0,0,screen_size.x, screen_size.y));
    view.setCenter(texture.getSize().x/2,texture.getSize().y/2);
    window.setView(view);
    sprite.setTextureRect(sf::IntRect(0,0,texture.getSize().x, texture.getSize().y));

    //std::vector<sf::Vector2f>  log_measures, log_outer_measures;
    //std::vector<sf::Vector2f> lin_measures, lin_outer_measures;
    std::vector<pt_datum> measures, outer_measures;
    int state = 0;
    float cur_angle = 0, start_angle=0, start_angle_outer = 0,start_angle_outer_loops=0;
    int nbr_loops = 0;

    sf::Vector2f lin_center;
    sf::Vector2f log_center;


    while (window.isOpen())
    {
        sf::Time elapsed = clock.restart();

        sf::Event event;
        while (window.pollEvent(event))
        {
            if(event.type == sf::Event::Closed)
                window.close();

            if(event.type == sf::Event::MouseMoved) {
                window.setView(view);

                sf::Vector2f newMouse = window.mapPixelToCoords(sf::Mouse::getPosition(window));
                if(state >= 1) ///OLD 3
                {
                    if(newMouse.y < lin_center.y
                        &&  mouse.y >= lin_center.y && newMouse.x  < lin_center.x)
                        nbr_loops ++;

                    if(newMouse.y >= lin_center.y
                        &&  mouse.y < lin_center.y &&newMouse.x  < lin_center.x)
                        nbr_loops --;

                    cur_angle = angle(lin_center, {.x=newMouse.x, .y=newMouse.y});
                }

                mouse = newMouse;

                if(state==2)
                {
                    std::vector<pt_datum> v;
                    v.push_back({.p=mouse,.loops=nbr_loops});
                    v.push_back({.p=measures[0].p,.loops=0});
                    lin_spire.ComputeBest(lin_center, v);
                }

                if(state==4 && outer_measures.size() == 1)
                {
                    std::vector<pt_datum> v;
                    v.push_back({.p=outer_measures.back().p,.loops=start_angle_outer_loops});
                    v.push_back({.p=mouse,.loops=nbr_loops});
                    lin_outer_spire.ComputeBest(lin_center, v);
                }
            }


            if(event.type == sf::Event::MouseButtonPressed && event.mouseButton.button == sf::Mouse::Right)
            {

                if(state == 4)
                {
                    for(int i = 0 ; i < outer_measures.size() ; i++)
                    {
                        if(abs(outer_measures[i].p.x - mouse.x) < 4 && abs(outer_measures[i].p.y - mouse.y) < 4)
                        {
                            outer_measures.erase(outer_measures.begin()+i), i--;
                            if(outer_measures.size() == 1)
                                start_angle_outer = angle(lin_center,outer_measures[0].p), start_angle_outer_loops=outer_measures[0].loops;
                        }
                    }
                }else{
                    for(int i = 0 ; i < measures.size() ; i++)
                    {
                        if(abs(measures[i].p.x - mouse.x) < 4 && abs(measures[i].p.y - mouse.y) < 4)
                        {
                            measures.erase(measures.begin()+i), i--;
                            if(measures.size() < 2)
                                state--;
                            if(state == 2)
                                start_angle = angle(lin_center,measures[0].p), measures[0].loops=0, nbr_loops=0;
                        }
                    }
                }


                lin_spire.ComputeBest(lin_center, measures);
                log_spire.ComputeBest(lin_center, measures);
                lin_outer_spire.ComputeBest(lin_center, outer_measures);
                log_outer_spire.ComputeBest(log_center, outer_measures);
            }

            if(event.type == sf::Event::MouseButtonPressed && event.mouseButton.button == sf::Mouse::Left)
            {
                if(state < 3)
                {
                    if(state == 0)
                        lin_center=mouse, log_center=mouse;

                    if(state == 1)
                    {
                        start_angle = cur_angle;
                        nbr_loops = 0;
                        measures.push_back({.p=mouse, .loops=0});
                    }

                    if(state == 2)
                    {
                        /*sf::Vector2f d = points[1] - points[0];
                        if(d.x != 0)
                        {
                            float a = d.y/d.x;
                            float b = points[0].y - a*points[0].x;
                            float b2 = mouse.y + 1/a*mouse.x;

                            points[2].x = (b2-b)/(a+1/a);
                            points[2].y = a * points[2].x + b;
                        } else
                            points[2].x = points[0].x;*/


                        {
                            /*float A = dist(points[0],points[1]);
                            float D = dist(points[0],points[2]);
                            float a = (3*A - D)/4;
                            float b = (D-A);

                            lin_center = points[0] + (A-a) * (points[2] - points[0])/dist(points[0],points[2]);
                            lin_spire.setParameters(a,b,true);*/
                           // measures.push_back({.p=points[0], .loops=(lin_center.y < points[1].y)});
                            measures.push_back({.p=mouse, .loops=nbr_loops});
                            lin_spire.ComputeBest(lin_center, measures);


                            /* float r0 = A*D/(A+D);
                             a = A - r0;
                             b = log(r0/a)*2;

                            log_center.x = points[0].x + r0 * (points[2].x - points[0].x)/dist(points[0],points[2]);
                            log_center.y = points[0].y + r0 * (points[2].y - points[0].y)/dist(points[0],points[2]);
                            log_spire.setParameters(a,b,true);*/

                            log_spire.ComputeBest(log_center, measures);
                        }
                    }
                    state++;
                }
                else
                {
                    if(state == 3)
                    {
                        measures.push_back({.p=mouse, .loops=nbr_loops});
                        lin_spire.ComputeBest(lin_center, measures);
                        log_spire.ComputeBest(log_center, measures);
                    } else {

                        outer_measures.push_back({.p=mouse, .loops=nbr_loops});

                        if(outer_measures.size()==1)
                        {
                            start_angle_outer = cur_angle;
                            start_angle_outer_loops = nbr_loops;
                        }
                        else {
                            lin_outer_spire.ComputeBest(lin_center, outer_measures);
                            log_outer_spire.ComputeBest(log_center, outer_measures);
                        }
                    }
                }

            }

            if(event.type == sf::Event::KeyPressed && event.key.code == sf::Keyboard::Return)
            {
                if(state == 3) state = 4;
                else if(state == 4) state = 3;
            }

            if(event.type == sf::Event::KeyPressed && event.key.code == sf::Keyboard::Space)
            {

                if(state >= 3) {
                fichier<<list_ammonites[cur_ammonite]<<":"<<std::endl;
                fichier<<"Linear: "<<lin_spire.printValues()<<std::endl;
                if(outer_measures.size() >= 2)
                    fichier<<"Outer linear: "<<lin_outer_spire.printValues()<<std::endl;

                fichier<<"Log: "<<log_spire.printValues()<<std::endl;
                if(outer_measures.size() >= 2)
                    fichier<<"Outer log: "<<log_outer_spire.printValues()<<std::endl;
                fichier<<std::endl;
                }

                sf::RenderTexture output_screen;
                output_screen.create(texture.getSize().x, texture.getSize().y);
                output_screen.setView(sf::View(sf::FloatRect(0,0,texture.getSize().x, texture.getSize().y)));


                output_screen.clear(sf::Color::White);
                output_screen.draw(sprite);


                if(state >= 3)
                {
                    lin_spire.Draw(&output_screen, lin_center, sf::Color::Yellow);
                    log_spire.Draw(&output_screen, log_center, sf::Color::Green);

                    sf::RectangleShape head_rect(sf::Vector2f(output_screen.getSize().x, 40));
                    head_rect.setFillColor(sf::Color(0,0,0,128));
                    output_screen.draw(head_rect);

                    writeText(&output_screen,"Inner spirals",{.x=8,.y=8});

                    sf::RectangleShape foot_rect(sf::Vector2f(output_screen.getSize().x, 80));
                    foot_rect.setFillColor(sf::Color(0,0,0,128));
                    foot_rect.setPosition({.x=0,.y=output_screen.getSize().y-foot_rect.getSize().y});

                    output_screen.draw(foot_rect);
                    writeText(&output_screen,"Lin : ",{.x=8,.y=output_screen.getSize().y-72},sf::Color::Yellow);
                    writeText(&output_screen,"Log : ",{.x=8,.y=output_screen.getSize().y-72+18+4},sf::Color::Green);
                    writeText(&output_screen,lin_spire.printValues(),{.x=58,.y=output_screen.getSize().y-72});
                    writeText(&output_screen,log_spire.printValues(),{.x=58,.y=output_screen.getSize().y-72+18+4});
                }

                output_screen.display();
                output_screen.getTexture().copyToImage().saveToFile("output/inner_"+list_ammonites[cur_ammonite]);

                if(outer_measures.size() >= 2)
                {
                    output_screen.clear(sf::Color::White);
                    output_screen.draw(sprite);

                    lin_outer_spire.Draw(&output_screen, lin_center, sf::Color::Yellow);
                    log_outer_spire.Draw(&output_screen, log_center, sf::Color::Green);


                    sf::RectangleShape head_rect(sf::Vector2f(output_screen.getSize().x, 40));
                    head_rect.setFillColor(sf::Color(0,0,0,128));
                    output_screen.draw(head_rect);

                    writeText(&output_screen,"Outer spirals",{.x=8,.y=8});

                    sf::RectangleShape foot_rect(sf::Vector2f(output_screen.getSize().x, 80));
                    foot_rect.setFillColor(sf::Color(0,0,0,128));
                    foot_rect.setPosition({.x=0,.y=output_screen.getSize().y-foot_rect.getSize().y});

                    output_screen.draw(foot_rect);
                    writeText(&output_screen,"Lin : ",{.x=8,.y=output_screen.getSize().y-72},sf::Color::Yellow);
                    writeText(&output_screen,"Log : ",{.x=8,.y=output_screen.getSize().y-72+18+4},sf::Color::Green);
                    writeText(&output_screen,lin_outer_spire.printValues(),{.x=58,.y=output_screen.getSize().y-72});
                    writeText(&output_screen,log_outer_spire.printValues(),{.x=58,.y=output_screen.getSize().y-72+18+4});

                    output_screen.display();
                    output_screen.getTexture().copyToImage().saveToFile("output/outer_"+list_ammonites[cur_ammonite]);
                }

                state = 0;
                measures.clear();
                outer_measures.clear();
                nbr_loops = 0;
                cur_ammonite++;
                if(cur_ammonite >= list_ammonites.size())
                    window.close();
                else
                    texture.loadFromFile("img/"+list_ammonites[cur_ammonite]);


                sf::Vector2u screen_size = texture.getSize();
                if(screen_size.x > 1000)
                    screen_size.x = 1000;
                if(screen_size.y > 700)
                    screen_size.y = 700;

                window.setSize(screen_size);
                view = sf::View(sf::FloatRect(0,0,screen_size.x, screen_size.y));
                zoom = 1;
                view.setCenter(texture.getSize().x/2,texture.getSize().y/2);
                window.setView(view);
                sprite.setTextureRect(sf::IntRect(0,0,texture.getSize().x, texture.getSize().y));
            }


            if(event.type == sf::Event::KeyPressed)
            {
                /*if(event.key.code == sf::Keyboard::Left)
                    lin_center.x--, log_center.x--;
                if(event.key.code == sf::Keyboard::Right)
                    lin_center.x++, log_center.x++;
                if(event.key.code == sf::Keyboard::Up)
                    lin_center.y--, log_center.y--;
                if(event.key.code == sf::Keyboard::Down)
                    lin_center.y++, log_center.y++;*/

                if(event.key.code == sf::Keyboard::C) {
                    lin_center = lin_spire.ComputeBestCenter(lin_center, measures);
                    log_center = log_spire.ComputeBestCenter(log_center, measures);
                }

                if(event.key.code == sf::Keyboard::BackSpace)
                {
                    if(state > 0 && state <= 3)
                    {
                        if(measures.size() <= 2)
                            state--;
                        if(!measures.empty())
                            measures.erase(measures.end());
                    }
                    if(state == 4 && !outer_measures.empty())
                            outer_measures.erase(outer_measures.end());
                }

                if(event.key.code == sf::Keyboard::O)
                {
                    zoom = 1;
                    view.setCenter(texture.getSize().x/2,texture.getSize().y/2);
                }

                lin_spire.ComputeBest(lin_center, measures);
                log_spire.ComputeBest(log_center, measures);
                lin_outer_spire.ComputeBest(lin_center, outer_measures);
                log_outer_spire.ComputeBest(log_center, outer_measures);
            }
        }
        if (sf::Keyboard::isKeyPressed(sf::Keyboard::Escape))
            window.close();


        if (sf::Keyboard::isKeyPressed(sf::Keyboard::R))
        {
            state = 0;
            measures.clear();
            outer_measures.clear();
            nbr_loops = 0;
        }



        if (sf::Keyboard::isKeyPressed(sf::Keyboard::PageUp))
            zoom*=1-elapsed.asSeconds();//view.zoom(1-elapsed.asSeconds());
        if (sf::Keyboard::isKeyPressed(sf::Keyboard::PageDown))
            zoom*=1+elapsed.asSeconds();//view.zoom(1+elapsed.asSeconds());

        if(sf::Mouse::getPosition(window).x < 8
            || sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
            view.move(sf::Vector2f(-elapsed.asSeconds()*300,0));
        if(sf::Mouse::getPosition(window).x > window.getSize().x-8
            || sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
            view.move(sf::Vector2f(elapsed.asSeconds()*300,0));
        if(sf::Mouse::getPosition(window).y < 8
            || sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
            view.move(sf::Vector2f(0,-elapsed.asSeconds()*300));
        if(sf::Mouse::getPosition(window).y > window.getSize().y-8
            || sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
            view.move(sf::Vector2f(0,elapsed.asSeconds()*300));

        view.setSize(window.getSize().x*zoom,window.getSize().y*zoom);

        window.setView(view);


        window.clear(sf::Color::White);

        window.draw(sprite);

        if(state > 0 && state < 3)
        {
            sf::Vector2f d = mouse - lin_center;

            if(state > 1)
                d = measures[0].p - lin_center;

            sf::Vector2f p1(lin_center),p2(lin_center);

            if(d.x != 0)
            {
                float a = d.y/d.x;
                float b = lin_center.y - a*lin_center.x;
                p1.x = view.getCenter().x-view.getSize().x*0.5;
                p1.y = a*p1.x + b;
                p2.x = view.getCenter().x+view.getSize().x*0.5;
                p2.y = a*p2.x + b;
            } else
            {
                p1.y = 0;
                p2.y = view.getSize().y;
            }

            drawLine(&window, p1,p2,sf::Color::Red);

           // if(state == 2)
             //   drawLine(&window, p3,p4,sf::Color::Red);

        }
        if(state >= 3)
        {
            sf::Vector2f d,c;
            sf::Color col;

           // if(mode == LIN)
            {
                col = sf::Color::Blue;
                c = lin_center;
            }
            /*if(mode == LOG)
            {
                col = sf::Color::Green;
                c = log_center;
            }*/
            d = mouse - c;

            sf::Vector2f p1(c),p2(c),p3,p4;

            if(d.x != 0)
            {
                float a = d.y/d.x;
                float b = c.y - a*c.x;

                p1.x = 0;
                p1.y = a*p1.x + b;
                p2.x = window.getSize().x;
                p2.y = a*p2.x + b;

                if(a != 0)
                {
                    float b2 = mouse.y + 1/a*mouse.x;
                    p3.x = 0;
                    p3.y = -p1.x/a + b2;
                    p4.x = window.getSize().x;
                    p4.y = -p2.x/a + b2;
                }
                else
                {
                    p3.y = 0;
                    p3.x = mouse.x;
                    p4.y = window.getSize().y;
                    p4.x = mouse.x;
                }
            } else
            {
                p1.y = 0;
                p2.y = window.getSize().y;

                p3.x = 0;
                p3.y = mouse.y;
                p4.x = window.getSize().x;
                p4.y = mouse.y;
            }



            drawLine(&window, p1,p2,col);
            drawLine(&window, p3,p4,col);
        }

        if(state==2)
            lin_spire.DrawArc(&window, lin_center,start_angle/PI*0.5,cur_angle/PI*0.5+nbr_loops,sf::Color::Red);
        if(state == 4 && outer_measures.size() == 1)
            lin_outer_spire.DrawArc(&window, lin_center,start_angle_outer/PI*0.5+start_angle_outer_loops,
                                    cur_angle/PI*0.5+nbr_loops,sf::Color::Red);

        if(state > 0 && state < 3)
            drawDot(&window, lin_center, 3, sf::Color::Red);
        for(int i = 0 ; i < state-1 && i < 3 ; i++)
            drawDot(&window, measures[i].p, 3, sf::Color::Red);

        for(int i = 0 ; i < measures.size() ; i++)
        {
            if(state == 3) drawDot(&window, measures[i].p, 5, sf::Color::Red);
            else drawDot(&window, measures[i].p, 3, sf::Color(255,0,0,128));
        }
        for(int i = 0 ; i < outer_measures.size() ; i++)
        {
            if(state == 4) drawDot(&window, outer_measures[i].p, 5, sf::Color::Red);
            else drawDot(&window, outer_measures[i].p, 3, sf::Color(255,0,0,128));
        }

        if(state == 3){
            lin_spire.Draw(&window, lin_center, sf::Color::Yellow);
            drawDot(&window, lin_center,3, sf::Color::Yellow);
            lin_spire.DrawDot(&window, lin_center, nbr_loops*2*PI+cur_angle,sf::Color::Yellow);
            log_spire.Draw(&window, log_center, sf::Color::Green);
            drawDot(&window, log_center,2, sf::Color::Green);
            log_spire.DrawDot(&window, log_center,  nbr_loops*2*PI+cur_angle,sf::Color::Green);

            if(outer_measures.size() >= 2) {
                lin_outer_spire.Draw(&window, lin_center, sf::Color(255,255,0,128));
                lin_outer_spire.DrawDot(&window, lin_center,  nbr_loops*2*PI+cur_angle,sf::Color(255,255,0,128));
                log_outer_spire.Draw(&window, log_center, sf::Color(0,255,0,128));
                log_outer_spire.DrawDot(&window, log_center, nbr_loops*2*PI+cur_angle,sf::Color(0,255,0,128));
            }
        }

        if(state == 4){
            lin_spire.Draw(&window, lin_center,sf::Color(255,255,0,128));
            drawDot(&window, lin_center,3, sf::Color(255,255,0,128));
            lin_spire.DrawDot(&window, lin_center,  nbr_loops*2*PI+cur_angle,sf::Color(255,255,0,128));
            log_spire.Draw(&window, log_center, sf::Color(0,255,0,128));
            drawDot(&window, log_center,2, sf::Color(0,255,0,128));
            log_spire.DrawDot(&window, log_center,  nbr_loops*2*PI+cur_angle,sf::Color(0,255,0,128));


            if(outer_measures.size() >= 2) {
                lin_outer_spire.Draw(&window, lin_center, sf::Color::Yellow);
                lin_outer_spire.DrawDot(&window, lin_center,  nbr_loops*2*PI+cur_angle,sf::Color::Yellow);
                log_outer_spire.Draw(&window, log_center, sf::Color::Green);
                log_outer_spire.DrawDot(&window, log_center,  nbr_loops*2*PI+cur_angle,sf::Color::Green);
            }
        }

        if(state >= 3)
        if (sf::Keyboard::isKeyPressed(sf::Keyboard::G))
        {
            LogSpiral fib_spire = log_spire;
            if(fib_spire.getRate() >0) fib_spire.setRate(0.301*PI*2);
            else fib_spire.setRate(-0.3063489*PI*2);
            fib_spire.Draw(&window,log_center,sf::Color::Magenta);
        }


        window.setView(sf::View(sf::FloatRect(0,0,window.getSize().x, window.getSize().y)));


        sf::RectangleShape head_rect(sf::Vector2f(window.getSize().x, 40));
        head_rect.setFillColor(sf::Color(0,0,0,128));
        window.draw(head_rect);

        if(state >= 3)
        {
            sf::RectangleShape foot_rect(sf::Vector2f(window.getSize().x, 80));
            foot_rect.setFillColor(sf::Color(0,0,0,128));
            foot_rect.setPosition({.x=0,.y=window.getSize().y-foot_rect.getSize().y});
            window.draw(foot_rect);

            writeText(&window,"Lin : ",{.x=8,.y=window.getSize().y-72},sf::Color::Yellow);
            writeText(&window,"Log : ",{.x=8,.y=window.getSize().y-72+18+4},sf::Color::Green);

            if(state == 3) {
                writeText(&window,lin_spire.printValues(),{.x=58,.y=window.getSize().y-72});
                writeText(&window,log_spire.printValues(),{.x=58,.y=window.getSize().y-72+18+4});
            } else if(outer_measures.size() >= 2) {
                writeText(&window,lin_outer_spire.printValues(),{.x=58,.y=window.getSize().y-72});
                writeText(&window,log_outer_spire.printValues(),{.x=58,.y=window.getSize().y-72+18+4});

                std::ostringstream ss;
                ss<<"Convolution : "<<(log_outer_spire.getRate()-log_spire.getRate())/log_outer_spire.getRate();
                writeText(&window,ss.str(),{.x=58,.y=window.getSize().y-72+36+4});
            }
        }


        {
            sf::Vector2f p(8,8);
            if(state == 0)
                writeText(&window,"Click to add estimated center",p);
            if(state == 1)
                writeText(&window,"Click to add first point on inner spiral",p);
            if(state == 2)
                writeText(&window,"Click to add second point on inner spiral",p);
            if(state == 3)
                writeText(&window,"Click to add points on inner spiral",p);

            if(state == 4)
            {
                if(outer_measures.empty())
                    writeText(&window,"Click to add first point on outer spiral",p);
                else if(outer_measures.size() == 1)
                    writeText(&window,"Click to add second point on outer spiral",p);
                else
                    writeText(&window,"Click to add points on outer spiral",p);
            }

        }

        writeText(&window,"?",{.x=window.getSize().x-16,8});
        if(sf::Mouse::getPosition(window).x > window.getSize().x-32 && sf::Mouse::getPosition(window).y < 32)
        {
            sf::RectangleShape mid_rect(sf::Vector2f(400, 260));
            mid_rect.setFillColor(sf::Color(0,0,0,128));
            mid_rect.setPosition({.x=window.getSize().x/2-200,.y=50});
            window.draw(mid_rect);
            writeText(&window, "List of keys:", {.x=mid_rect.getPosition().x+16, 58});
            writeText(&window, "[C] : compute best estimated center", {.x=mid_rect.getPosition().x+16, 58+40});
            writeText(&window, "[Enter] : change inner/outer spiral", {.x=mid_rect.getPosition().x+16, 58+60});
            writeText(&window, "[Space] : next specimen", {.x=mid_rect.getPosition().x+16, 58+80});
            writeText(&window, "[Backspace] : remove last point", {.x=mid_rect.getPosition().x+16, 58+100});
            writeText(&window, "[Right click] : remove point", {.x=mid_rect.getPosition().x+16, 58+120});
            writeText(&window, "[R] : reset specimen", {.x=mid_rect.getPosition().x+16, 58+140});
            writeText(&window, "[G] : draw Golden spiral", {.x=mid_rect.getPosition().x+16, 58+160});
            writeText(&window, "[PageUp] : zoom", {.x=mid_rect.getPosition().x+16, 58+180});
            writeText(&window, "[PageDown] : dezoom", {.x=mid_rect.getPosition().x+16, 58+200});
            writeText(&window, "[O] : reset view", {.x=mid_rect.getPosition().x+16, 58+220});
        }


        window.display();
    }

    fichier.close();
    return 0;
}
