#include "tools.h"

sf::Font font;

void drawLine(sf::RenderTarget *W, sf::Vector2f v1,sf::Vector2f v2, sf::Color c)
{
    sf::Vertex line[] =
    {
        sf::Vertex(v1, c),
        sf::Vertex(v2, c)
    };
    W->draw(line, 2, sf::Lines);
}

void drawDot(sf::RenderTarget *W, sf::Vector2f p, float r, sf::Color c)
{
    sf::CircleShape shape(r);
    shape.setFillColor(c);
    shape.setOrigin(sf::Vector2f(r,r));
    shape.setPosition(p);
    W->draw(shape);
}

void writeText(sf::RenderTarget *W, std::string s, sf::Vector2f p,sf::Color c)
{
    sf::Text txt;
    txt.setFont(font);
    txt.setCharacterSize(18);
    txt.setColor(sf::Color::White);
    txt.setPosition(p);
    txt.setString(s);
    txt.setColor(c);
    W->draw(txt);
}

float dot(sf::Vector2f p, sf::Vector2f q)
{
    return p.x*q.x + p.y*q.y;
}

float dist(sf::Vector2f p, sf::Vector2f q)
{
    sf::Vector2f d = p -q;
    return sqrt(dot(d,d));
}

float angle(sf::Vector2f s, sf::Vector2f e)
{
    float a = 0;
    if((e-s).x == 0)
    {
        if((e-s).y > 0)
            a = PI/2;
        else
            a = -PI/2;
    }
    else
        a = atan((e-s).y / (e-s).x);


    if((e-s).x < 0 && (e-s).y >= 0)
        a += PI;
    if((e-s).x < 0 && (e-s).y < 0)
        a -= PI;

    return a;
}

float abs(float a)
{
    if(a >= 0)
        return a;
    return -a;
}
